<template>
  <div class="q-pa-md">
    <div class="column">
      <div class="col" style="text-align: right">
        <q-btn tag="a" to="/jenis-produk/tambah" color="blue" icon="add" label="Tambah Jenis Produk" />
      </div>
    </div>

    <div class="column flex-center">
      <div class="col" style="margin-top: 10px; width: 100%">
        <q-table
          class="my-sticky-header-table"
          title="Daftar Referensi Jenis Produk"
          :data="dataTable"
          :columns="columns"
          row-key="name"
        >
          <template v-slot:top-right style="color: white !important;">
            <q-input borderless dense debounce="300" v-model="filter" placeholder="Cari Jenis Produk" color="white">
              <template v-slot:append style="color: white">
                <q-icon name="search"  />
              </template>
            </q-input>
          </template>

          <template v-slot:body="props">
            <q-tr :props="props" :key="`m_${props.row.index}`">
              <q-td
                key="index"
                :props="props"
              >
                {{ props.row.index }}.
              </q-td>
              <q-td key="product_type" :props="props" >{{ props.row.product_type }}</q-td>
              <q-td key="is_jasa" :props="props" >
                <q-badge v-if="props.row.is_jasa">Jasa</q-badge>
                <q-badge v-else>Lowongan Kerja</q-badge>
              </q-td>
              <q-td key="level_req" :props="props" >{{ props.row.level_req }}</q-td>
              <q-td key="desc" :props="props" >{{ props.row.desc }}</q-td>
              <q-td key="status" :props="props" >
                <q-badge align="middle" color="blue" v-if="props.row.status">Aktif</q-badge>
                <q-badge align="middle" color="red" v-else>Tidak Aktif</q-badge>
              </q-td>
              <q-td key="creator" :props="props" >{{ props.row.creator }}</q-td>
              <q-td key="tanggal_update" :props="props" >{{ props.row.tanggal_update }}</q-td>
              <q-td key="aksi" :props="props" >
                <q-btn
                  padding="none"
                  color="primary"
                  icon="edit"
                  :to="`jenis-produk/edit/${props.row.id}`"
                />
                <q-btn
                  style="margin-left: 3px"
                  padding="none"
                  color="primary"
                  icon="delete"
                  @click="confirmDelete(props.row.id, props.row.product_type)"
                />
              </q-td>
            </q-tr>
          </template>
        </q-table>
      </div>
    </div>

  </div>
</template>

<script>
  export default {
    name: "ListJenisProduk",

    data () {
      return {
        filter: null,
        columns: [
          {
            name: 'index',
            required: true,
            label: 'No',
            align: 'left',
            field: 'index',
            format: val => `${val}`,
            sortable: true
          },
          { name: 'product_type', align:'left', label: 'Tipe Produk', field: 'product_type', sortable: true },
          { name: 'is_jasa', align:'left', label: 'Tipe', field: 'is_jasa', sortable: true },
          { name: 'level_req', label: 'Level', field: 'level_req', sortable: true },
          { name: 'status', label: 'Status', field: 'status' },
          { name: 'creator', label: 'Update By', field: 'creator' },
          { name: 'tanggal_update', label: 'Last Update', field: 'tanggal_update' },
          { name: 'aksi', label: 'Aksi', field: 'id' }
        ],
        dataTable: [],
      }
    },

    beforeMount() {
      this.getBadanUsaha();
    },

    methods: {
      confirmDelete(val, name) {
        this.$q.dialog({
          title: 'Konfirmasi',
          message: 'Yakin Menghapus Jenis Produk' + name + "?",
          cancel: true,
          persistent: true
        }).onOk(() => {
          this.$router.push(`jenis-produk/hapus/${val}`);
        }).onOk(() => {
          // console.log('>>>> second OK catcher')
        }).onCancel(() => {
          // console.log('>>>> Cancel')
        }).onDismiss(() => {
          // console.log('I am triggered on both OK and Cancel')
        })
      },
      async getBadanUsaha() {
        let dataApi = {
          methods: "get",
          url: "api/product-type/list",
          headers: {
            Authorization: "Bearer " + localStorage.getItem("token")
          }
        }

        this.$q.loading.show()
        await this.$axios(dataApi)
          .then(sukses => {
            this.dataTable = sukses.data.data
            this.dataTable.forEach((row, index) => {
              row.index = index + 1
              let update = new Date(row.updated_at);
              row.tanggal_update = update.toLocaleDateString() + " , " +  update.toLocaleTimeString();
            })
          })
          .catch(error => {
            console.log(error.response)

          })
          .then(selalu => {
            this.$q.loading.hide()
          })
      },

      filterBadanUsaha: function () {
        alert("oke")
      }
    }
  }
</script>

<style lang="sass">
  .q-table--no-wrap td
    white-space: normal

    .my-sticky-header-table
      text-align: center

      .q-table__top,
      .q-table__bottom,
      thead tr:first-child th
        /* bg color is important for th; just specify one */
        background-color: #009688
        color: white
        font-size: 16px

      thead tr th
        position: sticky
        z-index: 1

      thead tr:first-child th
        top: 0

      /* this is when the loading indicator appears */
      &.q-table--loading thead tr:last-child th
        /* height of all previous header rows */
        top: 48px
</style>

<style>
thead {
  background-color: #c2c2c2;
}
.q-table__title {
  font-weight: bold;
}

.text-left, .text-right {
  text-align: center !important;
}
</style>
